﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using JRSteganoF2;
namespace JRSteganoExample
{
    class Program

    {

        static JRSteganoF2.JRStegano JrStegano1;

        static void Main(string[] args)
        {
            JrStegano1 = new JRSteganoF2.JRStegano();
            

            //in this demo the user must get a own serial number from jrsoft. The developer need only a user license too.
            JrStegano1.SerialNumber = 0;
            JrStegano1.RegCode = 0;

            JrStegano1.UseCryptService = false;
            JrStegano1.UserPassword = "";

            //copy files to ...
            //copy files who are stored in a picture to this path
            //        txt_copytopath.Text = System.AppDomain.CurrentDomain.BaseDirectory()


            //load a picture with data
            Console.WriteLine("Load stegano picture from file");

            //JrStegano1.Image = new Bitmap(System.AppDomain.CurrentDomain.BaseDirectory + "\\Picture_With_Datas.png");
            JrStegano1.LoadPictureFromFile (System.IO.Path.Combine (  System.AppDomain.CurrentDomain.BaseDirectory, "Picture_With_Datas.png"));



            //read the data inside the stegano picture and list in the listbox
            Console.WriteLine("Read the Datas inside the picture");
            Readdatas(0, false);


            Console.WriteLine("search for sample user data object with key usr2 in the stegano picture");
            ReadTestUserlist("usr2");


            Console.WriteLine("add string datas to the stegano picture");
            addtext("This is new text", true);


            Console.WriteLine("add more userlist objects ");
            addobject();


            Console.WriteLine("save the manipulated picture as Picture_With_Datas_new.png");
            JrStegano1.SaveAsPNG(System.IO.Path.Combine (System.AppDomain.CurrentDomain.BaseDirectory , "Picture_With_Datas_new.png"), true);

            Console.WriteLine("format the picture, all Data will be lost ");
            JrStegano1.ClearAllData();


            //read the data inside the stegano picture and list in the listbox
            Console.WriteLine("Read the Datas inside the picture");
            Readdatas(0, false);


            //load a picture with data
            Console.WriteLine("Load the manipulated picture Picture_With_Datas_new.png back");
            //JrStegano1.Image = new Bitmap(System.AppDomain.CurrentDomain.BaseDirectory + "\Picture_With_Datas_new.png");
            JrStegano1.LoadPictureFromFile(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "Picture_With_Datas_new.png"));


            Console.WriteLine("search for new created sample user data object with key^^ usr12 in the stegano picture");
            ReadTestUserlist("usr12");


            //Show use of individual Crypt service
            Console.WriteLine("format the picture, all Data will be lost ");
            JrStegano1.ClearAllData();

            JrStegano1.UseCryptService = true;
            JrStegano1.UserPassword = "thisismypassword";

            Console.WriteLine("add userlist objects crypted ");
            addobject();

            Console.WriteLine("search with wrong password ");
            JrStegano1.UserPassword = "thisismypasswort";
            ReadTestUserlist("usr12");

            Console.WriteLine("search with right password ");
            JrStegano1.UserPassword = "thisismypassword";
            ReadTestUserlist("usr12");


            Console.WriteLine("add some string crypted");
            addtext("This is new cryptet text1", true);
            addtext("This is new cryptet text2", true);
            addtext("This is new cryptet text3", true);
            addtext("This is new cryptet text4", true);



            Console.WriteLine("only for example, we add Picture_With_Datas_new.png to this stegano picture!");
            if (!JrStegano1.AddFileEx(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "Picture_With_Datas_new.png"), true))
            {
                Console.WriteLine("Can't add picture");
            }

            Console.WriteLine("We kill Picture_With_Datas_new.png! in the directory");
            System.IO.File.Delete(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory , "Picture_With_Datas_new.png"));



            //read the data inside the stegano picture and list in the listbox
            Console.WriteLine("We Read the Datas inside the picture and let copy files inside, so we get Picture_With_Datas_new.png back");
            Readdatas(0, true);


            //We open now the extracted Picture_With_Datas_new.png again
            Console.WriteLine("We Read the Datas from the eytracted Picture_With_Datas_new.png again to show datas are ok");
            JrStegano1.UseCryptService = false;
            JrStegano1.Image = new Bitmap(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "Picture_With_Datas_new.png"));


            //read the data inside the stegano picture and list in the listbox
            Console.WriteLine("We Read the Datas inside the extracted picture ");
            Readdatas(0, false);


            Console.WriteLine("search in the extracted picture for new created sample user data object with key usr12 in the stegano picture");
            ReadTestUserlist("usr12");


            Console.WriteLine("yes! stegano is safe and can be easy");

        }


        static  void addtext(string Newtext, bool autoresize)
        {
            if (!JrStegano1.AddTextEx(Newtext, autoresize))
            {
                Console.WriteLine("Can't add string");
            }
        }



        static  void addobject()
        {
            //Clear old datas if needed or load blank image from file
            //JrStegano1.ClearAllData()

            //Store any serializable class in the stegano picture
            //we store the same class with diferent datas the same time
            for (long x = 1; x <= 3; x++)
            {
                //Build the example test class we build a dll so we can serialize/deserialize from each project to each we want  
                examplemyusers.testclass.users xusers = new examplemyusers.testclass.users();
                xusers.myusers = new System.Collections.Generic.List<examplemyusers.testclass.user>();

                //set example datas
                examplemyusers.testclass.user user = default(examplemyusers.testclass.user);
                for (int n = 1; n <= 100; n++)
                {
                    user = new examplemyusers.testclass.user();
                    user.name = "NewUser_" + n + "_" + x;
                    user.password = "123456" + n;
                    xusers.myusers.Add(user);
                }

                //add the values to the stegano picture with a identifier key of max 5 chars
                string fixedlengthkey = "usr1" + x;
                fixedlengthkey = fixedlengthkey.PadLeft(5, ' ').Substring(0, 5);

                if (!JrStegano1.AddObjectEx(xusers, fixedlengthkey, true))
                {
                    Console.WriteLine("Datas not added");
                }
            }


        }



        static void ReadTestUserlist(string searchkey)
        {
            //Build the sample userlist class 
            examplemyusers.testclass.users xusers = new examplemyusers.testclass.users();
            xusers.myusers = new System.Collections.Generic.List<examplemyusers.testclass.user>();

            int listmax = 5;


            System.Collections.Generic.List<JRSteganoF2.ScanInfo> myfileInfos = default(System.Collections.Generic.List<JRSteganoF2.ScanInfo>);
            //Example we get only byte datas from the stegano picture    
            xusers = (examplemyusers.testclass.users)JrStegano1.ScanPicture_GetObject((searchkey));



            if ((xusers != null))
            {
                Console.WriteLine("Found Userlist");

                foreach (examplemyusers.testclass.user myuser in xusers.myusers)
                {
                    Console.WriteLine(myuser.name);
                    listmax = listmax - 1;
                    if (listmax == 0)
                    {
                        break; // TODO: might not be correct. Was : Exit For
                    }
                }
            }
            else
            {
                Console.WriteLine("not found");
            }
        }



        static void Readdatas(int method, bool copyfiles)
        {
            string FileCopyTo = "";

            if (copyfiles == true)
            {
                FileCopyTo = System.AppDomain.CurrentDomain.BaseDirectory;
            }

            bool OverwriteFiles = false;
            //    
            System.Collections.Generic.List<JRSteganoF2.ScanInfo> myfileInfos = default(System.Collections.Generic.List<JRSteganoF2.ScanInfo>);

            switch (method)
            {
                case 0:
                    //Example we get all data types from the stegano picture    
                    myfileInfos = JrStegano1.ScanPicture_GetAll(FileCopyTo, OverwriteFiles);
                    break;
                case 1:
                    //Example we get only string datas from the stegano picture    
                    myfileInfos = JrStegano1.ScanPicture_GetStrings();
                    break;
                case 2:
                    //Example we get only filenames and files from the stegano picture    
                    myfileInfos = JrStegano1.ScanPicture_GetFiles(FileCopyTo, OverwriteFiles);
                    break;
                case 3:
                    //Example we get only filenames and filesize from the stegano picture    
                    myfileInfos = JrStegano1.ScanPicture_GetFiles("", false);
                    break;
                case 4:
                    //Example we get only byte datas from the stegano picture    
                    myfileInfos = JrStegano1.ScanPicture_GetByteDatas();
                    break;
            }

            foreach (JRSteganoF2.ScanInfo myinfo in myfileInfos)
            {
                switch (myinfo.Type)
                {
                    case JRSteganoF2.JRStegano.Scanreq.TextDatas:
                        Console.WriteLine(myinfo.Value);
                        break;
                    case JRSteganoF2.JRStegano.Scanreq.Filename:
                        Console.WriteLine("Filename " + myinfo.Value + " Filesize" + myinfo.Size);
                        break;
                    case JRSteganoF2.JRStegano.Scanreq.FileDatas:
                        Console.WriteLine(myinfo.Size + " Bytes of File" + myinfo.Value);
                        break;
                    case JRSteganoF2.JRStegano.Scanreq.ByteDatas:
                        Console.WriteLine(myinfo.Size + " Bytes of Bytearray with Key=" + myinfo.Key);
                        break;
                }
            }

            //Be sure to set the eof behind last entry to add more datas to the picture
            JrStegano1.SetEOF();

        }

    
    }




}
